<template>
  <page
    title="Login"
    max-width="40em"
  >
    <formulary :submit="login">
      <v-text-field
        label="Email"
        name="email"
        type="email"
        v-model="email"
      />
      <hidden
        label="Password"
        name="password"
        v-model="password"
      />
    </formulary>
    <v-subheader>Ou use algum dos sequintes métodos</v-subheader>
    <v-btn
      :key="client.id"
      v-for="client in oauthClients"
      @click="externalLogin(client)"
    >
      <v-icon>{{client.icon}}</v-icon>
    </v-btn>
  </page>
</template>

<script lang="ts">
import Vue from 'vue'
import Page from '@/components/Page.vue'
import Formulary from '@/components/Formulary.vue'

import Hidden from '@/components/input/Hidden.vue'

import { oauthClients, Oauth2Config } from '@/oauth'

export default Vue.extend({
  name: 'LoginPage',
  components: {
    Page,
    Formulary,
    Hidden
  },
  data: () => ({
    email: '' as string,
    password: '' as string,
    oauthClients
  }),
  methods: {
    async login () {
      await this.$store.dispatch('auth/login', { email: this.email, password: this.password })
      await this.$router.go(0)
    },
    async externalLogin (client: Oauth2Config) {
      console.info(`Logging in via external provider: ${client.label}`)
      window.location.href = client.client.code.getUri()
    }
  }
})
</script>
